********************************************************
;	blok zameny operacionnoj sredy 'SCREEN-OS'
;  ----------------------------------------------------
;  wers.4.22				 data:21-DEC-91
;********************************************************

	MACLIB	SOSBAS

PLACE	EQU	BEGIN
EXTRN	ADV

	JMP	EXIT		; BEGIN+100H
	JMP	SYSTEM		;
	JMP	SCREEN		;
	JMP	ADV		; 
	JMP	READFILE	; 
	JMP	WRTFILE		; 
	JMP	DARK		;
	JMP	PREPHLFCB	;
	JMP	DISKERR		;
	JMP	DIRECTORY	;
	JMP	DELETEFILES	;
	JMP	PREPDIR		;

PUBLIC	EXDSC
EXDSC:
	DB	0
	DW	5CH		; FCB iz perwogo parametra
	DW	100H
	DW	0A000H

ADRDSM:	DS	2		; dannye dlq wosstanowleniq ob'ema diska s
DSM:	DS	2

STACK:	DS	2		; mesto dlq sohraneinq steka
STACKSOS:
	DW	EXSTACK		; stek dlq raboty s blokom SOS

;--------------------------------------------------------------------------
STATUS:	DB	0		;  0 --> sreda mikro-dos
				; -1 --> sreda |kranow

PUBLIC	EXIT
EXIT:
	LXI	SP,100H
	EI
	HLT
	DI
	CALL	DARK
	CALL	SYSTEM
	CALL	UNPREP
	JMP	0


PUBLIC	SCREEN
SCREEN:
	LDA	STATUS		; prowerka tipa sredy
	ORA	A
	RNZ

	MVI	A,-1
	JMP	EXMEDIA

PUBLIC	SYSTEM
SYSTEM:
	LDA	STATUS		; prowerka tipa sredy
	ORA	A
	RZ

	XRA	A
EXMEDIA:
	STA	STATUS
	CALL	DARK
	CALL	EXGOTO
	CALL	EXCHANGE
	RET

UNPREP:
	LHLD	DSM		; wosstanowitx ob'em diska C
	XCHG
	LHLD	ADRDSM
	MOV	M,E
	INX	H
	MOV	M,D
	RET


;  smena oblasti sistemnyh perehodow

PUBLIC	EXGOTO
EXGOTO:
	LXI	H,FIELD
	LXI	D,0
	MVI	C,8
	CALL	EXCOPY
	LXI	D,38H
	MVI	C,3

EXCOPY:
	MOV	B,M
	LDAX	D
	MOV	M,A
	MOV	A,B
	STAX	D
	INX	H
	INX	D
	DCR	C
	JNZ	EXCOPY
	RET

;  smena oblasti EXDISK i 7F00H

PUBLIC	EXEX
EXEX:
	LXI	H,EXDISK
	LXI	D,PLACE
	MVI	C,00H
	JMP	EXCOPY
	

;  obmen oblasti 0A000H-0FFFFH osnownoj pamqti i 0000H-5FFFH bloka 0 kwazidiska

PUBLIC	EXCHANGE
EXCHANGE:
	CALL	EXEX
	LXI	B,100H
	CALL	EXDISK
	LXI	B,201H
	CALL	EXDISK
	LXI	B,302H
	CALL	EXDISK
	JMP	EXEX

PUBLIC	FIELD
FIELD:
	DB	0,0,0,0,0,0,0,0,0,0,0

;  zatemnitx |kran na wremq smeny sredy

PUBLIC	DARK
DARK:
	LXI	H,100FH
CLCDARK:
	MOV	A,L
	OUT	2
	XRA	A
	OUT	0CH
	OUT	0CH
	INR	H
	OUT	0CH
	DCR	H
	OUT	0CH
	DCR	L
	OUT	0CH
	DCR	H
	OUT	0CH
	JNZ	CLCDARK

	RET

PUBLIC	DSC
DSC:
	DB	129
	DW	EXDSC

;  zapisx fajla
;  whod:
;    <HL> - adres FCB
;    <DE> - adres na~ala fajla
;    <BC> - adres konca fajla
WRTFILE:

IF	NOT(SHIELD-1)		; esli SHIELD=1 to wkl.za}ita
PUBLIC	MODE1,MODE2
EXTRN	CHECKBAS
	CALL	CHECKBAS
MODE1	EQU	$+1
	MVI	A,0E5H
MODE2	EQU	$+1
	SUI	0E5H
	STC
	RZ
ENDIF

	PUSH	H
	PUSH	D
	PUSH	B
	XCHG
	MVI	C,19		; udalitx fajl
	CALL	5
	POP	B
	POP	D
	POP	H

	MVI	A,-1
	JMP	$+4

;  ~tenie fajla
;  whod:
;    <HL> - adres FCB
;    <DE> - adres na~ala fajla
;    <BC> - adres konca fajla
READFILE:
	XRA	A
	STA	EXDSC

	SHLD	EXDSC+1
	XCHG
	SHLD	EXDSC+3
	MOV	H,B
	MOV	L,C
	SHLD	EXDSC+5
	

	XRA	A
	LXI	H,12
	DAD	D
	MOV	M,A
	LXI	H,32
	DAD	D
	MOV	M,A

IF	NOT(SHIELD-1)		; esli SHIELD=1 to wkl.za}ita
	CALL	CHECKBAS
ENDIF

	LXI	D,DSC
	MVI	C,50
	CALL	5
	ORA	A
	RET

;-------------------------------------------------------------
; podgotowitx FCB dlq zadannogo imeni
; whod:
;  <HL> - adres za zakrywa`}ej skobkoj imeni
;  <DE> - adres FCB
;  <A> - tip ras{ireniq
;    0 - .BAS
;    1 - .DBA
;   -1 - proizwolxnyj (zadaetsq w operatore)
;  adres na~ala imeni hranitsq w PFCB
; prime~anie:
;  zakr.kawy~ku sna~ala zamenitx 0, a zatem wosstanowitx
;  sohranqet zna~eniq reg.par <DE> i <HL>

STRA:	DS	1
ALL:	DB	'???????????'

PUBLIC	PREPHLFCB
PREPHLFCB:
	XCHG
	SHLD	@PFCB+2
	XCHG
	PUSH	PSW
	MOV	A,M
	STA	STRA
	MVI	M,0
	DCX	H
	MVI	M,' '
	PUSH	H
	MVI	C,152		; podgotowitx imq w FCB
	LXI	D,@PFCB
	CALL	5

	LHLD	@PFCB+2
	XCHG
	INX	D		; wse imena i ras{ireniq ?
	LDAX	D
	CPI	' '
	JNZ	YESNAME
	LXI	H,8
	DAD	D
	MOV	A,M
	CPI	' '
	LXI	H,ALL
	MVI	C,8+3
	CZ	COPY
YESNAME:

	POP	H
	MVI	M,'"'
	INX	H
	LDA	STRA
	MOV	M,A
	PUSH	H
	MVI	C,24
	CALL	5
	DCR	L
	MVI	B,2		; tolxko odin disk
	JZ	$+5
	MVI	B,4		; tri diska
	LHLD	@PFCB+2
	MOV	A,M
	CMP	B
	JNC	DERROR		; newerno ukazan disk
	XCHG
	LXI	H,12
	DAD	D
	MVI	M,0
	LXI	H,32
	DAD	D
	MVI	M,0
	POP	H
	POP	PSW
	ORA	A
	RM
	PUSH	H
	PUSH	D
	LXI	H,1+8
	DAD	D
	XCHG
	LXI	H,BASDIM
	JZ	$+6
	LXI	H,DBADIM
	MVI	C,3
	CALL	COPY
	POP	D
	POP	H
	RET

BASDIM:	DB	'BAS'
DBADIM:	DB	'DBA'

DERROR:
	MVI	C,2		; o{ibka wybora diska
	JMP	@DISKERR

TABERR:
	DW	ERRT00
	DW	ERRT01
	DW	ERRT02
	DW	ERRT03
	DW	ERRT04
	DW	ERRT05
	DW	ERRT06

;  podgotowka tekstowogo soob}eniq
DISKERR:
	MOV	A,C
	CPI	7
	MVI	A,7
	JNC	$+4
	MOV	A,C
	ADD	A
	LXI	H,TABERR
	ADD	L
	MOV	L,A
	JNC	$+4
	INR	H
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A

	LXI	D,@MESSAGE
	MVI	C,20H
COPY:
	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	C
	JNZ	COPY
	RET

ERRT00:
	DB	'net mesta w oglawlenii',0
	DB	0AH		; perepolnenie
ERRT01:
	DB	'net mesta na diske',0
	DB	0AH		; perepolnenie
ERRT02:
	DB	'o{ibka wybora diska',0
	DB	08H		; newernyj argument
ERRT03:
	DB	'neqwnoe imq',0
	DB	08H		; newernyj argument
ERRT04:
	DB	'o{ibka obmena s diskom',0
	DB	20H		; nelxzq
ERRT05:
	DB	'net fajla',0
	DB	20H		; nelxzq
ERRT06:
	DB	'net dannyh',0
	DB	08H		; newernyj argument
ERROR07:
	DB	'0'
	DB	02H		; sintaksi~eskaq o{ibka
;-------------------------------------------------------

@NAME:	DS	2

;  formirowanie spiska imen fajlow
;  whod:
;    <DE> - adres FCB
;  wyhod:
;    spisok fajlow s @FIELDNAME, zakan~iwa`}ijsq 00H

DIRECTORY:
	PUSH	D
	LXI	D,DIR
	MVI	C,26
	CALL	5
	LXI	H,FIELDN
	MVI	A,17		; poisk perwogo whoda
CLDIR:
	POP	D
	PUSH	D
	STA	MODEOPER
	SHLD	@NAME
	MVI	M,0		; priznak konca spiska imen

MODEOPER	EQU	$+1
	MVI	C,17
	CALL	5
	ORA	A
	JM	EOND

	RRC
	RRC
	RRC
	LXI	D,DIR
	ADD	E
	MOV	E,A

	INX	D		; imq fajla
	LHLD	@NAME
	MVI	C,8+3
	XCHG
	CALL	COPY
	XCHG
	MVI	A,18		; poisk sled.whoda
	JMP	CLDIR

EOND:
	POP	D
EON:
	MOV	A,H
	ORA	A
	RZ

;  obrabotka o{ibki obmena s diskom

	MVI	C,4
	JMP	@DISKERR

;  podgotowka imeni fajla dli BASIC
;  whod:
;    <DE> - adres w spiske imen
;  wyhod:
;    <DE> - adres sled.imeni
;    flag C=1 --> konec spiska imen

PREPDIR:
	LDAX	D
	ORA	A
	STC
	RZ		; konec spiska ?

	XCHG
	LXI	D,@MESSAGE
	MVI	C,8
	CALL	COPY
	MVI	A,'.'
	STAX	D
	INX	D
	MVI	C,3
	CALL	COPY
	XCHG
	MVI	A,'!'
	MOV	M,A
	INX	H
	MVI	A,' '
	MOV	M,A
	INX	H
	XRA	A
	MOV	M,A
	RET


;  udalenie fajlow
;  whod:
;    <DE> - adres FCB

DELETEFILES:
	LDAX	D
	ORA	A
	JNZ	$+7
	LDA	4		; teku}ij disk
	INR	A

	STAX	D
	MVI	C,19
	CALL	5
	ORA	A
	JM	EON
	RET

;-------------------------------------------------------
	DS	40H

EXSTACK:
	END

