
;***********************************************
;	  blok drajwerow BIOS 3.1.2
;  -------------------------------------------
;  wers.2.05			DATA:21-MAY-92
;***********************************************


EXTRN	CURS0,SPECKEYWM,SWITCHTABLETS

CHARGEN				EQU	0F300H
JMPRST8				EQU	38H
SCREEN				EQU	0A000H

	JMP	START
	JMP	CI
	JMP	RI
	JMP	CO
	JMP	PO
	JMP	LO
	JMP	STATCON
	JMP	LBYTE
	JMP	PEC
	JMP	INKEY

START:
	MVI	A,0C3H
	STA	JMPRST8
	LXI	H,RST7
	SHLD	JMPRST8+1
	MVI	A,0
	OUT	10H
	EI
	JMP	LFD89		; pozitiw

LO:
	PUSH	PSW

WAITLO:
	IN	5
	ANI	1
	JNZ	WAITLO
	MOV	A,C
	OUT	7
	MVI	A,0EFH
	OUT	5
	MVI	A,0FFH
	OUT	5
	POP	PSW
	RET

PEC:
	MOV	A,M
	ANA	A
	RZ
	PUSH	B
	MOV	C,M
	CALL	CO
	POP	B
	INX	H
	JMP	PEC

LBYTE:
	MOV	B,A
	MOV	A,B
	RRC
	RRC
	RRC
	RRC
	CALL	CLOW
	MOV	A,B

CLOW:
	ANI	0FH
	CPI	0AH
	JM	DECIMAL
	ADI	7

DECIMAL:
	ADI	'0'	;30H
	MOV	C,A
	JMP	CO

RI:
	PUSH	B
	PUSH	D
	MVI	C,0
	MOV	D,A
	IN	1
	ANI	10H
	MOV	E,A

RBIT:
	IN	1
	ANI	10H
	CMP	E
	JZ	RBIT
	RLC
	RLC
	RLC
	RLC
	MOV	A,C
	RAL
	MOV	C,A
	CALL	RDELAY
	IN	1
	ANI	10H
	MOV	E,A
	MOV	A,D
	ORA	A
	JP	NEXTBIT
	MOV	A,C
	CPI	0E6H
	JNZ	READ
	XRA	A
	STA	INVERS
	JMP	FINDSYNCH

READ:
	CPI	19H
	JNZ	RBIT
	MVI	A,0FFH
	STA	INVERS

FINDSYNCH:
	MVI	D,9

NEXTBIT:
	DCR	D
	JNZ	RBIT
	LDA	INVERS
	XRA	C
	POP	D
	POP	B
	RET

RDELAY:
	PUSH	PSW
	LDA	RDEL

RCKL:
	DCR	A
	JNZ	RCKL
	POP	PSW
	RET

PO:
	PUSH	B
	PUSH	D
	PUSH	PSW
	MOV	D,A
	MVI	C,8

WBIT:
	MOV	A,D
	RLC
	MOV	D,A
	MVI	A,1
	XRA	D
	ANI	1
	OUT	0
	CALL	WDELAY
	MVI	A,0
	XRA	D
	ANI	1
	OUT	0
	CALL	WDELAY
	DCR	C
	JNZ	WBIT
	POP	PSW
	POP	D
	POP	B
	RET

WDELAY:
	PUSH	PSW
	LDA	WDEL
	JMP	RCKL

SHRF0:
	DW	CHARGEN
	DW	CHARGEN+0A0H
	DW	CHARGEN+140H
	DW	CHARGEN+1E0H
	DW	CHARGEN+280H
	DW	CHARGEN+320H
	DW	CHARGEN+3C0H
	DW	CHARGEN+460H

SHRF1:
	DW	CHARGEN
	DW	CHARGEN+0A0H
	DW	CHARGEN+3C0H
	DW	CHARGEN+460H
	DW	CHARGEN+280H
	DW	CHARGEN+320H
	DW	CHARGEN+140H
	DW	CHARGEN+1E0H

SHRF2:
	DW	CHARGEN
	DW	CHARGEN+0A0H
	DW	CHARGEN+140H
	DW	CHARGEN+460H
	DW	CHARGEN+280H
	DW	CHARGEN+320H
	DW	CHARGEN+1E0H
	DW	CHARGEN+3C0H

SHRF3:
	DW	CHARGEN
	DW	CHARGEN+0A0H
	DW	CHARGEN+140H
	DW	CHARGEN+1E0H
	DW	CHARGEN+280H
	DW	CHARGEN+320H
	DW	CHARGEN+3C0H
	DW	CHARGEN+460H

LF92D:
	PUSH	H
	LXI	H,0
	DAD	SP
	LXI	SP,0
	XRA	A
	OUT	10H
	LDA	MARKTIME
	CALL	CURSOR
	XRA	A
	STA	LFFC6
	JMP	EXOFF

DARKCURSOR:
	XRA	A

PUBLIC	CURSOR
CURSOR:
	STA	TIMER+1
	PUSH	H
	PUSH	D
	PUSH	B
	PUSH	PSW
	CALL	TVXY
	DCR	E
	POP	PSW
	MVI	H,7

SEVENPOINT:
	PUSH	H
	ANA	A
	JZ	DARKPOINT
	PUSH	PSW
	CALL	ADRESTV
	ORA	M
	JMP	LIGHTPOINT

DARKPOINT:
	PUSH	PSW
	CALL	ADRESTV
	CMA
	ANA	M

LIGHTPOINT:
	MOV	M,A
	XCHG
	POP	PSW
	POP	H
	INX	B
	DCR	H
	JNZ	SEVENPOINT
	POP	B
	POP	D
	POP	H
	RET

ONLYCO:
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LDA	TIMER+1
	ANA	A

	CNZ	DARKCURSOR

CIRCLECO:
	LXI	H,STATCO
	MOV	A,M
	CPI	80H
	JZ	NOWGRF
	CPI	'@'	;40H
	JZ	CHANGECOLOR
	CPI	' '	;20H
	JZ	OUTGRCHR
	CPI	60H
	JZ	REGPOZNEG
	ORA	A
	JNZ	SEQAR2
;
; STATCO=0 !!!
	MOV	A,C
	CPI	1BH
	JNZ	NOTAR2

INCSTATCO:
	INR	M
	JMP	EXCO2

NOTAR2:
	CPI	1
	JNZ	NOT01HSYMBOL
;
;  sled. wywoditx tolxko kak simwol (ne reag. na upr. kody)
	MVI	A,80H
	STA	STATCO
	JMP	EXCO2

NOT01HSYMBOL:
	CPI	0CH
	JZ	CLRSCREEN
	CPI	1FH
	JM	CTRL1
	JMP	OUTGRCHR

SEQPOZNEG:
	MVI	M,60H
	JMP	EXCO2

REGPOZNEG:
	MOV	A,C
	CPI	'C'	;43H
	JZ	NEGATIVE
	CPI	'@'	;40H
	JZ	POZITIVE
	CPI	'A'	;41H
	JZ	NEGATIVE
	MVI	M,0
	JMP	CIRCLECO

SEQAR2:
	CPI	1
	JNZ	SETCOORD
	MOV	A,C
	CPI	80H
	JNC	LFA92
	CPI	'Y'	;59H
	JZ	INCSTATCO
	CPI	'T'	;54H
	JZ	INCSTATCO
	CPI	'E'	;45H
	MVI	C,0CH
	JZ	INIDISP
	CPI	'J'	;4AH
	MVI	C,0CH
	JZ	INTERNALSYMBOL
	CPI	'K'	;4BH
	JZ	RIGHTCLEAR
	MVI	C,0BH
	JZ	INTERNALSYMBOL
	CPI	'M'	;4DH
	JZ	LFA40
	CPI	'L'	;4CH
	JZ	LFA4A
	CPI	'H'	;48H
	JZ	INTERNALSYMBOL
	CPI	5EH
	JZ	SEQPOZNEG
	CPI	5CH
	JZ	SETFONT2
	CPI	5BH
	JZ	SETFONT3
	CPI	'P'	;50H
	JZ	FONCHRCOLOR
	CPI	61H
	JZ	POZITIVE
	CPI	'7'	;37H
	JZ	POZITIVE
	CPI	62H
	JZ	NEGATIVE
	CPI	'6'	;36H
	JZ	NEGATIVE
	JMP	ZEROSTATCO

LFA40:
	CALL	TVXY
	MOV	A,E
	STA	LFFCA
	JMP	ZEROSTATCO

LFA4A:
	CALL	TVXY
	MOV	B,E
	LDA	LFFCA
	CMP	E
	JZ	RIGHTCLEAR
	JNC	LFA7D
	MOV	A,B
	ADI	0AH
	MOV	B,A
	LDA	LFFCA
	MOV	E,A
	ADI	0AH
	LXI	H,2C1CH

LFA65:
	SHLD	LFA8D
	MOV	L,A
	MVI	C,'@'	;40H
	MVI	D,0A0H

LFA6D:
	MOV	H,D
	PUSH	H
	PUSH	D
	CALL	LFA88
	POP	D
	POP	H
	INR	D
	DCR	C
	JNZ	LFA6D
	JMP	RIGHTCLEAR

LFA7D:
	ADI	0AH
	MOV	E,A
	SUI	0AH
	LXI	H,2D1DH
	JMP	LFA65

LFA88:
	MOV	A,B
	CMP	L
	RZ
	MOV	A,M
	STAX	D

LFA8D:
	INR	L
	INR	E
	JMP	LFA88
;
;  obrabotka wtorogo bajta posl. 1BH,80H+Y,80H+X

LFA92:
	INR	M

LFA93:
	SUI	60H
	MOV	C,A

SETCOORD:
	MOV	A,C
	CPI	80H
	JNC	LFA93
	MOV	A,M
	CPI	3
	JNC	LFAC6
	MOV	A,C
	SUI	' '	;20H
	JM	LFAB0
	CPI	19H
	JM	SETYCOORD

LFAB0:
	MVI	A,18H

SETYCOORD:
	RLC
	MOV	C,A
	RLC
	RLC
	ADD	C
	CMA
	INR	A
	SUI	0AH
	MOV	C,A
	LDA	ROLIC
	ADD	C
	STA	YTV
	JMP	INCSTATCO

LFAC6:
	MOV	A,C
	SUI	' '	;20H
	JM	LFAD7
	CPI	'P'	;50H
	JM	LFAD9

LFAD7:
	MVI	A,'O'	;4FH

LFAD9:
	STA	XTV

ZEROSTATCO:
	LXI	H,STATCO
	MVI	M,0
	JMP	EXCO2

OUTGRCHR:
	LXI	H,SHRF0
	MOV	A,C
	ANA	A
	JZ	EXCO2
	MVI	D,8
;
; poisk linejki w tablice fontow

SEARCHFONTLINE:
	SUI	' '	;20H
	JNC	NEXTFONTLINE
	ADI	' '	;20H
	JMP	FINDLINEFONT

NEXTFONTLINE:
	INX	H
	INX	H
	DCR	D
	JNZ	SEARCHFONTLINE

FINDLINEFONT:
	MOV	C,M
	INX	H
	MOV	B,M
	MVI	H,0
;
; <A> := kod znaka & 1FH
	MOV	L,A
	MOV	D,H
	MOV	E,L
	DAD	H
	DAD	H
	DAD	D
	DAD	B
	PUSH	H
	CALL	TVXY
	LXI	H,CHARGEN
	CALL	OUT8POINT
	MVI	D,5
	POP	H

LFB17:
	INX	B
	CALL	OUT8POINT
	INX	H
	DCR	D
	JNZ	LFB17
	JMP	LFBA6
;
; wywod 8 to~ek w wide wert. poloski

OUT8POINT:
	PUSH	H
	PUSH	D
	PUSH	B

	CALL	CURS0		; 1.1

	XCHG
	MOV	D,A
	CMA
	MOV	E,A
	MOV	B,L

LFB36:
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	INR	L
	MOV	A,D
	ORA	M
	MOV	M,A
	MOV	L,B
	JMP	LFB61

LFB5D:
	MOV	C,A

LFB5E:
	MOV	A,E
	ANA	M
	MOV	M,A

LFB61:
	MOV	A,C
	ANA	A
	CNZ	LFB6D
	JC	LFB5D
	POP	B
	POP	D
	POP	H
	RET

LFB6D:
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RC
	INR	L
	ADD	A
	RET
;
; wyhod: <BC> - 1FFH & (XTV*6+10), <E> - YTV

TVXY:
	LDA	XTV
	MOV	L,A
	MVI	H,0
	DAD	H
	PUSH	H
	POP	B
	DAD	H
	DAD	B
	LXI	B,10H
	DAD	B
	MOV	A,H
	ANI	1
	MOV	B,A
	MOV	C,L
	LDA	YTV
	MOV	E,A
	RET
;
; whod:<BC> - X, <E> - Y koord. to~ki
; wyhod: <HL> - adres, <A> - maska

ADRESTV:
	PUSH	B		; 1.1
	CALL	CURS0		;
	POP	B		;
	XCHG
	RET

LFBA6:
	LXI	H,XTV
	INR	M
	MOV	A,M
	CPI	'P'	;50H
	JM	EXCO2

LFBB0:
	MVI	M,0
	LDA	YTV
	SUI	0AH
	STA	YTV
	MOV	C,A
	ADI	4
	MOV	B,A
	LDA	ROLIC
	CMP	B
	JNZ	EXCO2
	SUI	0AH
	STA	ROLIC
	MOV	A,C
	SUI	5
	MOV	C,A
	MVI	H,0A0H
	MVI	A,0E0H
	MVI	D,0

LFBD4:
	MOV	L,C
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	L
	MOV	M,D
	INR	H
	CMP	H
	JNZ	LFBD4
	JMP	EXCO2
; 
; steretx prawu` ~astx stroki

RIGHTCLEAR:
	CALL	TVXY

LFBFB:
	PUSH	D
	PUSH	B

	CALL	CURS0		; dopoln.

	CMA
	ANA	A
	JM	LFC0B
	XRA	A

LFC0B:
	XCHG
	MOV	D,A
	MOV	B,L
	MOV	L,B
	MVI	E,9
	JZ	LFC34

LFC14:
	MOV	A,D
	ANA	M
	MOV	M,A
	INR	L
	DCR	E
	JNZ	LFC14

LFC1C:
	MOV	A,D
	POP	B
	POP	D
	LXI	H,1
	ANA	A
	JNZ	LFC28
	MVI	L,8

LFC28:
	DAD	B
	MOV	B,H
	MOV	C,L
	MOV	A,B
	CPI	2
	JNZ	LFBFB
	JMP	ZEROSTATCO

LFC34:
	MOV	A,H
	SUI	' '	;20H
	MOV	B,A
	MOV	C,L
	MOV	A,D

LFC3A:
	MOV	M,A
	STAX	B
	INR	C
	INR	L
	DCR	E
	JNZ	LFC3A
	JMP	LFC1C

CLRSCREEN:
	LXI	H,0
	DAD	SP
	SHLD	RESETSTACK+1
	DI
	LXI	SP,SCREEN+4000H
	LXI	B,0
	LXI	D,0FFF8H
	LXI	H,3FF8H

LFC59:
	PUSH	B
	PUSH	B
	PUSH	B
	PUSH	B
	DAD	D
	JC	LFC59

RESETSTACK:
	LXI	SP,0
	LXI	H,ROLIC
	MVI	M,0FFH
	JMP	HOME

CTRL1:
	MOV	A,C
	CPI	16H
	JZ	RIGHTCLEAR
	CPI	8
	LXI	H,XTV
	JNZ	LFCA2
	MOV	A,M
	DCR	A

LFC7C:
	JP	LFC80
	XRA	A

LFC80:
	CPI	'O'	;4FH
	JC	LFC86
	XRA	A

LFC86:
	MOV	M,A

EXCO2:
	LDA	STATCO
	CPI	' '	;20H
	JNZ	LFC9D
	LDA	XTV
	ANI	7
	MVI	C,' '	;20H
	JNZ	CIRCLECO
	XRA	A
	STA	STATCO

LFC9D:
	POP	H
	POP	D
	POP	B
	POP	PSW
	RET

LFCA2:
	CPI	18H
	JNZ	LFCAC
	MOV	A,M
	INR	A
	JMP	LFC7C

LFCAC:
	CPI	0AH
	JNZ	LFCB4
	JMP	LFBB0

LFCB4:
	CPI	0BH
	JZ	HOME
	CPI	0EH
	JZ	SETFONT1
	CPI	0FH
	JZ	SETFONT0
	CPI	7
	JZ	BELL
	CPI	9
	JZ	TABTURNON
	JMP	LFCDF

HOME:
	XRA	A
	STA	XTV
	LDA	ROLIC
	SUI	0AH
	STA	YTV
	JMP	EXCO2

LFCDF:
	CPI	0DH
	JNZ	LFCE8
	XRA	A
	JMP	LFC86

LFCE8:
	CPI	19H
	LXI	H,YTV
	JNZ	LFD07
	LDA	ROLIC
	MVI	C,0AH

LFCF5:
	INR	M
	CMP	M
	JZ	LFD01
	DCR	C
	JNZ	LFCF5
	JMP	EXCO2

LFD01:
	SUI	0FAH

LFD03:
	MOV	M,A
	JMP	EXCO2

LFD07:
	CPI	1AH
	JNZ	OUTGRCHR
	LDA	ROLIC
	MVI	C,0AH

LFD11:
	DCR	M
	CMP	M
	JZ	LFD1D
	DCR	C
	JNZ	LFD11
	JMP	EXCO2

LFD1D:
	SUI	0AH
	JMP	LFD03
;
; posle wnutr. nastrojki obrabotatx simwol iz <C> kak uprawl.

INTERNALSYMBOL:
	XRA	A
	STA	STATCO
	JMP	CIRCLECO

NOWGRF:
	XRA	A
	STA	STATCO
	JMP	OUTGRCHR
;
; inicializaciq displeq

INIDISP:
	LXI	H,SHRF0
	SHLD	OUTGRCHR+1
	CALL	LFD89
	JMP	INTERNALSYMBOL

SETFONT1:
	LXI	H,SHRF1
	JMP	SETFONTS

SETFONT0:
	LXI	H,SHRF0
	JMP	SETFONTS

SETFONT2:
	LXI	H,SHRF2
	JMP	SETFONTS
;
; tablica koi-8

SETFONT3:
	LXI	H,SHRF3

SETFONTS:
	SHLD	OUTGRCHR+1
	JMP	ZEROSTATCO

FONCHRCOLOR:
	MVI	A,'@'	;40H
	STA	STATCO
	JMP	EXCO2

CHANGECOLOR:
	LDA	LFFC2
	CPI	0
	JZ	LFD72
	XRA	A
	STA	LFFC2
	MOV	A,C
	STA	CLRCHR
	JMP	ZEROSTATCO

LFD72:
	INR	A
	STA	LFFC2
	MOV	A,C
	STA	CLRFON
	JMP	EXCO2

POZITIVE:
	XRA	A
	JMP	SETPOZNEG

NEGATIVE:
	MVI	A,1

SETPOZNEG:
	CALL	LFD8A
	JMP	ZEROSTATCO

LFD89:
	XRA	A

LFD8A:
	LXI	D,0A67BH
	LXI	H,0B67AH
	ANA	A
	JZ	LFD95
	XCHG

LFD95:
	SHLD	LFB5E
	MVI	A,9
	LXI	H,LFB36

LFD9D:
	MOV	M,E
	INX	H
	MOV	M,D
	INX	H
	INX	H
	INX	H
	DCR	A
	JNZ	LFD9D
	RET

BELL:
	LXI	H,1002H

LFDAB:
	HLT
	DCR	H
	MVI	A,'6'	;36H
	OUT	8
	MOV	A,L
	OUT	0BH
	MOV	A,H
	OUT	0BH
	JNZ	LFDAB
	JMP	ZEROSTATCO

TABTURNON:
	MVI	A,' '	;20H
	STA	STATCO
	MOV	C,A
	JMP	CIRCLECO

RST7:
	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LHLD	CLRFON
	LXI	D,100FH

SETCOLOR:
	MOV	A,E
	OUT	2
	ANI	6
	MOV	A,L
	JZ	CASECOLOR
	MOV	A,H

CASECOLOR:
	OUT	0CH
	PUSH	PSW
	POP	PSW
	PUSH	PSW
	POP	PSW
	PUSH	PSW
	POP	PSW
	DCR	E
	DCR	D
	OUT	0CH
	JNZ	SETCOLOR
	LHLD	TIMER
	INX	H
	SHLD	TIMER
	MVI	A,8AH
	OUT	0
	MOV	A,L
	ANI	7
	MOV	H,A
	ANI	4
	MOV	L,A
	LDA	MARKTIME
	CMP	H
	MOV	A,L
	STA	MARKTIME
	JZ	LFE0B
	MVI	A,1
	STA	LFFC6

LFE0B:
	IN	1
	ANI	80H
	LXI	H,RUSLATKEY
	JNZ	NORUSKEY
	MOV	A,M
	ORA	A
	JZ	LFE28
	MVI	M,0

	LXI	H,STATCI		; 1.1
	MOV	A,M			;
	XRI	0A8H			;
	MOV	M,A			;
	JMP	LFE28

NORUSKEY:
	MVI	M,0FFH

LFE28:
	XRA	A
	OUT	3
	IN	2
	CPI	0FFH
	JZ	NOKEYPRESS
	LXI	B,0FE08H
	LXI	D,0800H
	MOV	A,B

LFE39:
	OUT	3
	IN	2
	CPI	0FFH
	JNZ	CLROW
	MOV	A,E
	ADD	D
	MOV	E,A
	MOV	A,B
	RLC
	MOV	B,A
	DCR	C
	JNZ	LFE39

NOKEYPRESS:
	CALL	LFF38
	XRA	A
	STA	FRSTDELAY
	CMA
	STA	OLDKEY
	JMP	EXRST7

CLROW:
	RAR
	JNC	FINDROW
	INR	E
	JMP	CLROW

FINDROW:
	CALL	LFF38
	LXI	H,CONTRST7
	PUSH	H
	IN	1
	ANI	60H
	MOV	B,A
	MOV	A,E
	CPI	'?'	;3FH
	MVI	A,' '	;20H
	RZ
	MOV	A,E
	CPI	10H
	JNC	LFE8C

	CALL	SPECIALKEY		; 1.1

	MVI	D,0
	DAD	D
	MOV	A,M
	CPI	7FH
	RNZ
	MOV	A,B
	ANI	' '	;20H
	MVI	A,5FH
	RZ
	MOV	A,M
	RET

LFE8C:
	CPI	' '	;20H
	JNC	LFEAB
	CPI	1CH
	MOV	A,B
	JNC	LFEA2
	ANI	' '	;20H
	MOV	A,E
	JZ	LFE9F

LFE9D:
	ADI	10H

LFE9F:
	ADI	10H
	RET

LFEA2:
	ANI	' '	;20H
	MOV	A,E
	JNZ	LFE9F
	JMP	LFE9D

LFEAB:
	MOV	A,B
	ANI	'@'	;40H
	JNZ	LFEB5
	MOV	A,E
	ANI	1FH
	RET

LFEB5:
	MOV	A,B
	ANI	' '	;20H
	MOV	B,A
	LDA	STATCI
	ANI	40H			; 1.1
	ORA	B
	MOV	A,E
	JPO	LFEC5
	ADI	' '	;20H

LFEC5:
	ADI	' '	;20H
	RET

SPECIALKEY:
	LXI	H,SPECKEYWM		; 1.2
	MOV	A,B			;
	ANI	60H			;
	RRC				;
	RRC				;
	RRC				;
	RRC				;
	ADD	L			;
	MOV	L,A			;
	JNC	$+4			;
	INR	H			;
	MOV	A,M			;
	INX	H			;
	MOV	H,M			;
	MOV	L,A			;
	RET				;

CONTRST7:
	LXI	H,EXRST7
	PUSH	H
	MOV	B,A
	LDA	OLDKEY
	CPI	0FFH
	JZ	LFEFD
	CMP	B
	RNZ
	LXI	H,FRSTDELAY
	MOV	A,M
	CPI	'2'	;32H
	JZ	LFEF2

LFEF0:
	INR	M
	RET

LFEF2:
	LXI	H,NEXTDELAY
	MOV	A,M
	CPI	5
	JNZ	LFEF0
	MVI	M,0

LFEFD:
	MOV	A,B
	STA	OLDKEY

	CALL	SWITCHTABLETS	; 1.2

	CPI	80H
	JNZ	LL		; 1.1
	LXI	H,STATCI	;
	MOV	A,M		;
	XRI	40H		;
	MOV	M,A		;
	RET			;
LL:				;
	CPI	'@'		;
	JC	STOREKEYTOBUF	;
	INR	A		;
	JM	STOREKEYTOBUF	;
	LDA	STATCI		;
	ANI	0A0H		;
	XRA	B		;
	MOV	B,A		;

STOREKEYTOBUF:
	LXI	H,QCHAR
	MOV	A,M
	CPI	8
	RNC
	INR	M
	LDA	CHARCOUNT
	MOV	E,A
	MVI	D,0
	LXI	H,RINGCI
	DAD	D
	INR	A
	ANI	7
	STA	CHARCOUNT
	MOV	M,B
	RET

LFF38:
	MVI	A,88H
	OUT	0
	LDA	STATCI
	ANI	9
	OUT	1
	LDA	ROLIC
	OUT	3
	MVI	A,10H
	OUT	2
	RET

EXRST7:
	POP	H
	POP	D
	POP	B
	POP	PSW
	EI
	RET

STATCON:
	LDA	LFFC6
	ANA	A
	CNZ	LF92D
	LDA	QCHAR
	ANA	A
	RZ
	MVI	A,0FFH
	RET

CI:
	CALL	INKEY
	CPI	0FFH
	JZ	CI
	RET

INKEY:
	PUSH	B
	PUSH	H
	CALL	STATCON
	LXI	H,QCHAR
	MOV	A,M
	ORA	A
	JNZ	KEYISPRESSED
	DCR	A
	POP	H
	POP	B
	RET

KEYISPRESSED:
	DCR	M
	LXI	H,RINGCI
	LDA	COUNTCI
	MOV	C,A
	MVI	B,0
	DAD	B
	INR	A
	ANI	7
	STA	COUNTCI
	MOV	A,M
	POP	H
	POP	B
	RET

CO:
	PUSH	H
	LXI	H,0
	DAD	SP
	LXI	SP,0
	PUSH	PSW
	XRA	A
	OUT	10H
	POP	PSW
	CALL	ONLYCO

EXOFF:
	PUSH	PSW
	MVI	A,0
	OUT	10H
	POP	PSW
	EI
	SPHL
	POP	H
	RET

ROLIC:
	DB	0FFH

YTV:
	DB	00H

XTV:
	DB	00H

STATCO:
	DB	00H

NEXTDELAY:
	DB	00H

FRSTDELAY:
	DB	00H

STATCI:
	DB	06H

OLDKEY:
	DB	00H

RUSLATKEY:
	DB	0FFH

QCHAR:
	DB	00H

CHARCOUNT:
	DB	00H

COUNTCI:
	DB	00H

RINGCI:
	DS	0008H

PUBLIC	CLRFON,CLRCHR
CLRFON:
	DB	00H

CLRCHR:
	DB	0F6H

CAPSSHIFT:
	DB	00H

LFFC2:
	DB	00H

MARKTIME:
	DB	00H

WDEL:
	DB	32H

RDEL:
	DB	4BH

LFFC6:
	DB	00H

TIMER:
	DB	02H
	DB	00H

INVERS:
	DB	00H

LFFCA:
	DB	00H

	END
