/*******************************************************
           ADD1200V
--------------------------------------------------------
  / .		10.09.93
*********************************************************
       			29.10.93

      	
      	
  .						

  int	F_Trans (rgm)					
  int rgm;						
 							
  rgm -   :F_SEND - 	
 				F_RESND  -    
 				F_RECEIV - 	
 				F_RERCV - 	
  Return: 	OK					
 		WRONG_ARG				
 		TR_ABRT					

*/

#include	<mdmv23.h>
#define	RDFL 0
#define WRFL 1
#define BUFPC 0x686
#define PC 0x5

#define 	SOH	0x01
#define 	EOT	0x04
#define 	ENQ	0x05
#define 	ACK	0x06
#define		NAK	0x15
#define 	SYN	0x16
#define 	BELL	0x07

#define 	SUCCESS		0
#define 	WRONG_ARG	-1
#define 	TR_ABRT		1

#define 	FM_IDLE		0
#define 	ABEND		1
#define 	COMPLETE	2
#define 	FM_EXIT		3
#define 	SEND_DWNLD	4
#define 	WAIT_BELL	5
#define 	SEND_FDSCR	6
#define 	WAIT_ENQ	7
#define 	SEND_BLOCK	8
#define 	WAIT_ACK	9
#define 	SEND_BELL	10
#define 	WAIT_FDSCR	11
#define 	SEND_ENQ	12
#define 	RCV_BLOCK	13
#define 	SEND_ACK	14
#define 	FORM_FDSCR	15

#define 	BELL_REPEAT	6
#define 	FDSCR_TIME	10
#define 	FDSCR_LEN	25

/*-----------------------------------------*/

int F_Trans(rgm)
int rgm;
{

 int    i;
 int	bell_cnt;
 int	fdscr_cnt;
 int	fm_state;
 int	ex_code;
 int	len_blk;
 int	max_len_blk;

 at_dl_str="ADD_link?";
 enq_pkt.ptype=ENQ;

 switch (rgm)
	{
	 case F_RESND:
		resnd_flg = 1;
	 case F_SEND:
		fm_state = FORM_FDSCR;break;
	 case F_RECEIV:
		rec_flg = 1;
		enq_pkt.mx_len_bl = 512;

	 case F_RERCV:
		bell_cnt = BELL_REPEAT;
		fdscr_cnt = FDSCR_TIME;
		fm_state = SEND_BELL; break;

	 default:
		ex_code = WRONG_ARG ;
		fm_state = FM_EXIT ;
	}

 while ( fm_state != FM_EXIT )
    {
      switch (fm_state)
	{
/*==========           =======================*/

	case FORM_FDSCR:
	/*    ,
	    .   -   
	   .					*/

		if (Frm_FDCR()==OK)
		  {
		    if (resnd_flg) dt_tm = 1;
		    resnd_flg = 0;
		    fm_state = SEND_DWNLD; 
		  }
		else
		  {	 
		    ex_code=TR_ABRT;
		    fm_state = ABEND;
		   }			 
		break;


	case SEND_DWNLD:
	/*   , 
	      :
	  BELL+AT_LOAD_STRING
	      BELL.		*/

		 sprintf (bufdata,"%c%s%c",BELL,at_dl_str,BELL);
		 Put_Blk (bufdata,11);

/*		 Out_Byte (BELL);
		 Put_Blk (at_dl_str,9);
		 Out_Byte (BELL);			*/

		 fm_state = WAIT_BELL;
		 break;
	
	case WAIT_BELL:
	/*  BELL (   ).   
	   ,   .
	    BELL      
	        .
	*/
		if(Inp_Byte(&byte_pkt)&&(byte_pkt==BELL))
			{ 
			 fm_state=SEND_FDSCR;
			}
		break;

	case	SEND_FDSCR:
	/*     ,  
	          
	*/

		if ((Put_Blk(&typ_pkt,FDSCR_LEN))==OK)
			{
			for (i=1;i*4<f_len;i++);
			Marker(1,i); 
			fm_state=WAIT_ENQ;
			}
		else
			{
			 ex_code=TR_ABRT;
			 fm_state = ABEND;
			}			 
		break;

	case	WAIT_ENQ:
	/* O       .
	   ACK     .
	     NAC,      
	   -  .
	*/
		if ( Inp_Byte(&byte_pkt) )
		  {
		    switch (byte_pkt)
			{
			  case ENQ:
				Print(" ...");
				if (Get_Blk(&enq_pkt.e_nmb,2)==OK)
				    {
				  if (seek(fd,(enq_pkt.e_nmb-1)*4,0)!=ERROR)
					{
				          for (i=0;i<(enq_pkt.e_nmb-1);i++)
				          Marker (2,i);
					  fm_state=SEND_BLOCK;
					}
				     else 
					{
					  fm_state=ABEND;
					}
				    }
				else fm_state=ABEND;
				if (Get_Blk(&max_len_blk,2)!=OK)fm_state=ABEND;
				break;

			  case ACK:
				fm_state=COMPLETE;break;   
			  case NAK:
				ex_code=TR_ABRT;
				fm_state=ABEND;
				break;
			  case BELL:
			  case  'P':
			  case  'V':
				break;
			  default:
				ex_code=TR_ABRT;
				fm_state=ABEND;	
			}
		  }
		 break;

	case SEND_BLOCK:
	/*       ,
	          .
	        EOT  
	   .       
	    .
	*/
		 if ((ex_code=read(fd,bufdata,4))!=ERROR)
		    {
		     if (ex_code)
			{
			  len_blk = ex_code*128;
			  Out_Byte(SOH);
			  Put_Blk(&len_blk,2);
			  Put_Blk(bufdata,len_blk);
			  Marker(2,enq_pkt.e_nmb-1);
			  enq_pkt.e_nmb ++;
			  fm_state = WAIT_ACK;
			}
		     else
			{
			  Out_Byte(EOT);
			  fabort (fd);
			  
			  print ("  .");
			  ex_code = OK;
			  fm_state = COMPLETE;
			}
		    }
		else fm_state=ABEND;
		break;			

	case WAIT_ACK:
	/*       .
	     ACK -   .
	     NAK -   .
	*/
		if (Inp_Byte(&byte_pkt))
		    switch (byte_pkt)
			{
			  case ACK:	fm_state = SEND_BLOCK;break;
			  default:	printf(" %2x ",byte_pkt);
					ex_code = TR_ABRT;
/*					fm_state = ABEND;	*/
			}
		break;

/*	--------------	    -------------	*/
	case SEND_BELL:
	/*      BELL  
	      .
	          ,
	     .
	*/

		Print (" ");
		if (-- bell_cnt)
		    {
		      sprintf (bufdata,"%cV",BELL);
		      Put_blk (bufdata,2);
		      fm_state = WAIT_FDSCR;
		    }
		else
		    {
		      ex_code = TR_ABRT;
		      fm_state = ABEND;
		    }
		break;

	case WAIT_FDSCR:
	/*        .
	       -  .
	           
	        .
	       ,  ACK.
	       NAK   .
	*/
		if (Inp_Byte(&byte_pkt))
		    {
		      if (byte_pkt==SYN)
			{
			  Print(" ...");
			  if (Get_Blk(&typ_pkt+1,FDSCR_LEN-1)==OK)
			    {
			      shownm(bfname);
			      if ((i=Prep_ENQ())==ERROR) 
				{
				  Out_Byte(NAK);
				  fm_state = ABEND;
				}
			      else 
				{
				  enq_pkt.e_nmb = i;
				  fm_state = SEND_ENQ;
				}
			    }
			  else fm_state = ABEND;  
			}
		    }
		else
		    {
		      if (!(-- fdscr_cnt))
			{
			  fdscr_cnt= FDSCR_TIME;
			  fm_state = SEND_BELL;
			}
		    }
		break;

	case SEND_ENQ:
	/*    ,     .
	*/
		
		Put_Blk (&enq_pkt.ptype,sizeof(enq_pkt));
		fm_state = RCV_BLOCK;
		rcv_f = 1;
		Print ("  ...");
		break;
		
	case RCV_BLOCK:
	/*        ,
	       .
	          .
	          
	    .
	*/
		if (Inp_Byte(&byte_pkt))
		  switch (byte_pkt)
		    {
		      case EOT:
			if (close(fd)==ERROR)
			  {
			    Print ("   !!!");
			    fm_state = ABEND;
			  }
			else
			  {
			     if (F_Copy ("c:$$$.$$$",bfname)==ERROR)
				fm_state = ABEND;
			    else
			      {
			        Print(" .");
				ex_code = OK;
				rcv_f = 0;
			        fm_state = COMPLETE;
			      }
			  }
			break;

		      case SOH:
			if ((ex_code = Get_Blk(&len_blk,2))==OK)
			  {
			    if ((ex_code = Get_Blk(bufdata,len_blk))==OK)
			      {
			       for (i = 1; i*128 < len_blk; i++);
			       if ((ex_code = write (fd,bufdata,i))!=ERROR)
			        {
				  Marker (2,enq_pkt.e_nmb-1);	
				  enq_pkt.e_nmb ++;
				  fm_state = SEND_ACK;
			        }
			    else 
				{
				fm_state = ABEND;
				Print ("  !!!");
				}
			      }
			    else
			      {
				 fm_state = ABEND;
			      }	
			  }
			else fm_state = ABEND;
			break;

		      default:
			ex_code = TR_ABRT;
			fm_state = ABEND;
		    }
		break;

	case SEND_ACK:
	/*      	*/
		Out_Byte(ACK);
		fm_state = RCV_BLOCK;
		break;

	case ABEND:
	/*      
	      .
	*/
		if (rcv_f)
			{
			  close (fd);
			  F_Copy ("c:$$$.$$$",bfname);
			}
		unlink ("c:$$$.$$$");
		rcv_f     = 0;
		rec_flg   = 0;
		fm_state  = FM_EXIT;
		bios (3);
		break;

	case COMPLETE:
	/*     	*/
		unlink ("c:$$$.$$$");
		Marker (0,0);
		rec_flg   = 0;
		ex_code = OK;
		fm_state = FM_EXIT;
	break;

	}
/*    .
      -  
       - ERROR
*/
    if (( Regen_Chan())==ERROR && fm_state != COMPLETE &&
					  fm_state != FM_EXIT)
      {
	ex_code = ERROR;
	fm_state = ABEND;
      }

/*    "".
     -  .
*/
    if (US_Check())
      {
	Print ("  !!!");
	ex_code = TR_ABRT;
	fm_state = ABEND;
      }
    }
 Marker (0,0);
 return ex_code;
}

/*================   =======================*/

/*
 US_Check () 
    "".  	
					
 :	    -  	
		ERROR -         	

*/
int US_Check()
{
 if ( inp(1) & 0x40 ) return OK;
 else return ERROR;
}


/*
 Frm_FDCR () 
   ,   	
   .		
					
 :	    			
		ERROR 	        	

*/
int Frm_FDCR()
{
 typ_pkt = SYN;
 typ_prog = 'V';
 f_len0 = 0;
 dt_tm0 = 0;
 dt_tm = 0;
 blk_len = 512;

 asknm(bfname); 
 if (F_Copy(bfname,"c:$$$.$$$")==ERROR) return ERROR;
 if ((fd=open("c:$$$.$$$",0))==ERROR)
    {
      Print("  !!");
      return (ERROR);
    }
 f_len = cfsize(fd); 
 return OK;
}

/*
 F_Copy(f_name1,f_name2) 
                      	
					
 :	    			
		ERROR 	        	

*/
int F_Copy (f_name1,f_name2)
char *f_name1;
char *f_name2;
{
int i;
int fd1,fd2;

 if ((fd1=open(f_name1,0))==ERROR)
    {
      Print("  !!!");
      return (ERROR);
    }


 if ((fd2 = creat (f_name2))==ERROR)
    {
      Print ("   !!!");
      return ERROR;
    }

 while (i = read (fd1,bufdata,32))
    {
      if (i==ERROR)
	{
	  Print ("  !!!");
	  return ERROR;
	}
      if (write(fd2,bufdata,i) != i)
	{
	  Print ("   !!!");
	  return ERROR;
	 }
    }
 close (fd1);
 if (close (fd2)==ERROR)
    {
      Print ("   !!!");
      return ERROR;
    }
 return OK;
}

/*
 Put_Blk (b_buf,b_size) 
     .	
 char *b_buf -   .  
 int   b_size-  .		
					
 :	    -  	
		ERROR -    	
		US    -   	

*/

int Put_Blk (b_buf,b_size)
char *b_buf;
int   b_size;
{
  int i,j;
  
  j = 0;
  do
    {
      b_size -=j;
      b_buf +=j;
      j = Out_Blk (b_buf,b_size);  
      i = Regen_Chan();
      if (US_Check()) i = US;
    }while ((i != ERROR) && (i!=US) && (j != b_size));
  if ( i != US)i=OK; 
  return i;
}

/*
 Out_Byte (o_byte) 
     .		
 :	    -  .	
		ERROR -  .	

*/

int Out_Byte (o_byte)
char o_byte;
{
 char p;
 p=o_byte;
 return Put_Blk (&p,1);
}

/*
 Out_Blk (b_bo,b_so) 
     .	
 char *b_buf -   .  
 int   b_size-  .		
					
 :	 	
		                   	

*/

int Out_Blk (b_bo,b_so)
int b_so;
char *b_bo;
{
  return call(BLK_OUT,0,b_bo,0,b_so);
}


/*
 Get_Blk (b_bf,b_siz) 
      .	
 char *b_bf -   . 
 int   b_siz-  .		
					
 :	    -  	
		ERROR -    	

*/

int Get_Blk (b_bf,b_siz)
char *b_bf;
int   b_siz;
{
  int i,j;

  j = 0 ;
  do
    {
      b_siz -= j ;
      b_bf  += j ;
      j = Inp_Blk (b_bf,b_siz);
      i= Regen_Chan();
      if (US_Check())i=US;
    } while ((i != ERROR) && (i != US) && (j != b_siz));
  if ( i != US)i=OK; 
  return i;
}

/*
 Inp_Byte (p_i_byte) 
      -	
    p_i_byte.		
					
 :	0  -   .	
		1  -  .	

*/
int Inp_Byte (p_i_byte)
char *p_i_byte;
{
 int i;

 i=Inp_Blk(p_i_byte,1);
/* putch(*p_i_byte);*/
 return i;
}

/*
 Inp_Blk (b_bi,b_si) 
      .	
 char *b_bi -   .	
 int   b_si-  .		
					
 :	   	
		 .         	

*/
int Inp_Blk (b_bi,b_si)
int b_bi;
char *b_si;
{
  return call (BLK_IN,0,b_bi,0,b_si);
}


/*
 Regen_Chan ( ) 
   .       	
					
 :	    -   	
		ERROR -    	

*/
int Regen_Chan()
{
  return call (REG_CH,0,0,0,0);
}

/*
 Init_Chan_Buf ( ) 
   .      	
					

*/
int Init_Chan_Buf ()
{
  return call (INIT_CH,0,0,0,0);
}
/*
 Exit_Chan ( ) 
 ""                 	
					

*/
int Exit_Chan ()
{
  return call (EXIT_CH,0,0,0,0);
}

/*
 Prep_ENQ ( ) 
       	
  .						
      :			
				  enq_pkt.e_nmb = 1	
     -     ˃
 C     .     ,	
      >= , -	
       enq_pkt.e_nmb = 1
 	e_nmb -    .		
							
 :	N     - enq_pkt.nmb 			
		ERROR -    	
							

*/
int Prep_ENQ ()
{
 int en;

  if (rec_flg) en = F_Creat ();
  else if ((en = F_Open())==ERROR) en = F_Creat ();
  return en;
}

/*
 F_Creat ( ) 
   C      	
  "$$$.$$$"			
					
 :	1     -    	
		ERROR -          	

*/
int F_Creat ()
{
 int i,j;
  if ((fd=creat("c:$$$.$$$"))==ERROR)
    {
      Print ("   !!!");
      j = ERROR;;  
    }
  else
    {
      for (i=1;i*4<f_len;i++);
      Marker (1,i);
      j = 1;
    }
  return j;
}

/*
 F_Open ( ) 
   C   	
  "$$$.$$$" ,  	
 bfname.
					
 :	N     -    	
		ERROR -  ,  	
			  C	

*/
int F_Open ()
{
 int j,i;

  if (F_Copy(bfname,"c:$$$.$$$")==ERROR) return ERROR;
  if ((fd=open("c:$$$.$$$",2))==ERROR)
    {
      Print("  !!");
      return (ERROR);
    }
  if ((i=cfsize(fd)) > f_len)
    {
      fabort (fd);
      return ERROR; 
    }
  for (j=1;j*4<i;j++);
  seek (fd,(j-1)*4,0);
  for (i=1;i*4<f_len;i++);
  Marker (1,i);
  for (i=0;i<(j-1);i++)
  Marker (2,i);
  return j;
}

